#!/bin/bash

# This script uses "convert" from the ImageMagick package:
# http://www.imagemagick.org/

# test if no argument is given or help is requested:
if [ -z "$1" ]
then
echo -e "\nScript to scale down images, create thumbnail size and medium resolution images for dFG \n http://www.vlado-do.de/download/downloadE.html#dfg\n"
echo -e "Move (or link) your images into the one directory and call this:\n"
echo -e "$0 [img1] [img2] [...]\n"
else

# Set size and quality of images, medium size images, and thumbnail size
# images

MAIN_SIZE=992
MID_SIZE=640
THUMB_SIZE=150

MAIN_QUAL=75
MID_QUAL=70
THUMB_QUAL=70

# create the necessary subdirectories
mkdir images midRes thumbs

args=$#
count=1
while [ -n "$*" ]
do
echo -n "Processing image $count of $args ($1) "
newname=$(echo "$1" | sed 's/.JPG/.jpg/')
convert -geometry "$MAIN_SIZE"x"$MAIN_SIZE" -quality $MAIN_QUAL $1 images/$newname && echo -n "O"
convert -geometry "$MID_SIZE"x"$MID_SIZE" -quality $MID_QUAL $1 midRes/$newname && echo -n "o"
# use resized image as the source for the thumbnail / speeds up creation:
convert -geometry "$THUMB_SIZE"x"$THUMB_SIZE" -quality $THUMB_QUAL images/$newname thumbs/$newname && echo "."
let "count+=1"
shift
done

fi
