<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<?php  
require 'dfg-conf.inc.php';
include 'dfg_version.php';

/* Gallery description in English: */
$THUMBS_TXT="photos.txt";

/* PHP save_mode? */
if (ini_get('safe_mode')) $safemode = true;
else $safemode = false;


$src = $_GET['src'];
if (!preg_match("/[\/]$/", $src)) $src = $src . "/";

if (!isset($_GET['seite'])) $seite=1;
else $seite = $_GET['seite'];

if (is_file($src . "fotos-conf.inc.php")) include $src . 'fotos-conf.inc.php';

/* Mit welchem Bild auf dieser Thumbnail-Seite angefangen wird */

$nr = ($seite - 1) * $BPS;

// Adopt German title, if English in not available:
if (!isset($TITLE) || ($TITLE == "" && $TITLE_D !== ""))
  $TITLE = $TITLE_D;

?>

<head>
  <title>Photo Gallery <?php echo stripslashes($TITLE); ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=<?php echo $CHARSET ?>" />
  <meta name="description" content="Photo Gallery created with dFG V<?php echo $DFG_VERSION ?> (http://dfg.fieroch.de)" />
  <meta name="robots" content="follow" />
  <?php print $HEAD; ?>
</head>

<body>
<?php 
include 'dfg-login.inc.php';

function save($text) {
  if (!file_exists($text)) touch($text);
  if (is_writeable($text)) {
    $f = fopen($text, "w"); 
    fwrite($f, stripslashes($_POST['txt'])) or die("<strong>ERROR:</strong> could not save comment!");
    fclose($f);
  }
  else {
    print "<strong>ERROR:</strong> File $text is write-protected!";
    exit;
  }
}




if ($_COOKIE["dfg-Admin"] != null && $PASSWORD == $_COOKIE['dfg-Admin']) {
  $text = $src . $THUMBS_TXT;
  if ($_POST['saveTxt']) { 
    save($text);
  }

  /* Text lschen */
  if ($_POST['delText'] && is_file($text)) {
    unlink($text) or die("<strong>ERROR:</strong> Die Datei $text konnte nicht gel&ouml;scht werden!");
  }

  /* Datei-Upload */
  if (isset($_FILES['upload']) and ! $_FILES['upload']['error']) {
    move_uploaded_file($_FILES['upload']['tmp_name'], $src."images/" . $_FILES['upload']['name']);
  }
}





/** 
 * hier wird berprft, ob es Thumbnails gibt 
 * und fehlende werden gegebenfalls erstellt 
 */
$dirimg = $src . "images";

if (!is_dir($src)) die("<strong>ERROR:</strong> Directory &quot;$src&quot; does not exist!<br />(Mind that PHP is case-sensitive)");

/* The server does not always need write permissions / I generate images locally

if (!is_writable($src)) {
  print "<strong>ERROR:</strong> Directory &quot;$src&quot; is not writable!<br />
         Please allow the web-server to write on &quot;$src&quot;.";
  exit;
}

*/

if (!is_dir($src . "thumbs")) {
  if (!$safemode) mkdir($src . "thumbs", 0777);
  else die("<strong>ERROR:</strong> Server is running in <em>php safe_mode</em>!<br />The directory &quot;thumbs&quot; needs to be created manually in &quot;$src&quot; and has to be given write permissions, for this script to work nevertheless!");
}

if ($handle = opendir($dirimg)) {
  while (false !== ($file = readdir($handle))) { 
    /* gibt es dazu ein thumbnail? */
    if (is_file($dirimg . "/" .$file)) {
      if (!is_file($src . "thumbs/" .$file)) {

	/* ist die Datei berhaupt ein untersttztes Bild (2=JPG, 3=PNG)? */
	$imgsrc = $dirimg."/".$file; //Die URL zum Original-Bild
	$typ = GetImageSize($imgsrc);
	switch ($typ[2]) {
	case 2: 
	  createThumbs($imgsrc, $file, 2); //JPG
	  break;
	case 3:
	  createThumbs($imgsrc, $file, 3); //PNG
	  break;
	default:
	  // echo "$file is not a supported image format";
	  break;
	}
      }
    }
  }
  closedir($handle); 
}




function createThumbs($imgsrc, $file, $typ) {
  /* hier werden die Thumbs erstellt */
  global $src;
  global $THUMB_SIZE;
  global $THUMB_QUALITY;

  $thumbdir = $src . "thumbs/"; //Das Verzeichnis, in dem die Thumbnails abgelegt werden
  
  $size = GetImageSize($imgsrc);
  
  /* Querformat oder Hochformat? */
  if ($size[0] > $size[1]) {
    // Querformat
    $w = $THUMB_SIZE; //default Breite
    $h = $w * $size[1]/$size[0];
  }
  else {
    // Hochformat
    $h = $THUMB_SIZE; //default Hhe
    $w = $h * $size[0]/$size[1];
  }

  $thumb = imagecreatetruecolor($w, $h);
  if ($typ == 2) $image = ImageCreateFromJpeg($imgsrc);
  else if ($typ == 3) $image = ImageCreateFromPNG($imgsrc);

  if (!$safemode) @set_time_limit(0);

  ImageCopyResampled($thumb, $image, 0, 0, 0, 0, $w, $h, $size[0], $size[1]) or die("Error creating image");

  if ($typ == 2) ImageJPEG($thumb, $thumbdir.$file, $THUMB_QUALITY) or die("Error saving image");
  else if ($typ == 3) ImagePNG($thumb, $thumbdir.$file, $THUMB_QUALITY) or die("Error saving image");
}

function get_img_title($img_name)
{
  global $src;
  /* Initialisation of $img_title */
  $img_title=$img_name;
  $img_title_ger="";
  $text_file= $src . "text/" . $img_name . ".txt";
  if (file_exists($text_file)) {
    /* overrides $img_title, if successful */
    include $text_file;
  }
  /* Take German image titles, if English titles are not available: */
  if ( ($img_title == $img_name || $img_title == "") && $img_title_ger !== "")
    $img_title = $img_title_ger; 
  return strip_jpg($img_title);
}

/* This function prints a table with arrows to navigate through multiple thumbnail pages */

function thumb_nav($page_nr, $thumbsseiten, $src, $left_arrow, $right_arrow, $descr_link)
{
print "\n\n<table class=\"thumb_nav\">\n<colgroup>\n   <col width=\"1*\" /><col width=\"150px\" /><col width=\"1*\" />\n</colgroup>";
  print "\n<tr>\n   <td style=\"text-align:right\">&nbsp;";
  if ($page_nr == 1) {
    if ($descr_link)
      print "<div class=\"description-link\"><a href=\"descriptions.php?src=" . urlencode($src) . "\">[ All image descriptions on one page ]</a></div>";
  }
  else{
    $left_arrow_size = GetImageSize($left_arrow);
    print "<a href=\"thumbnails.php?src=" . urlencode($src) . "&amp;seite=" . ($page_nr-1) . "\"><img class=\"thumb_back\" src=\"" . $left_arrow . "\" alt=\"&larr;\" width=\"" . $left_arrow_size[0] . "\" height=\"" . $left_arrow_size[1] . "\" title=\"Previous\" /></a>";
  }
  print "</td>";
  print "\n   <td style=\"text-align:center\">Page " . $page_nr . " of " . $thumbsseiten . "</td>"; 
  print "\n   <td style=\"text-align:left\">";
  if ($page_nr < $thumbsseiten) {
    print "<a href=\"thumbnails.php?src=" . urlencode($src) . "&amp;seite=" . ($page_nr + 1) . "\">";
    print "<img class=\"thumb_forw\" src=\"" . $right_arrow . "\" alt=\"Next\" title=\"Next\" /></a>";
  }
  print "    &nbsp;</td>\n</tr></table>"; 
}

/* hier werden die Thumbnails eingelesen */
$dir = $src . "thumbs";
if ($handle = opendir($dir)) {

  while (false !== ($file = readdir($handle))) { 
    if (is_file($dir."/".$file)) {
      $thumbs[] = $file;

    }
  }
  sort($thumbs);
  
  /* errechnet die bentigte Seitenanzahl */
  $size = count($thumbs);
  $thumbsseiten = (int) ($size / $BPS);
  if ($size % $BPS != 0) $thumbsseiten++;
	
  closedir($handle); 
}
?>


<div class="top_frame">

<a name="Top"></a>

<?php

print $TOP_NAV;

/* Die Sprachwechsel-Flagge wird nur angezeigt, wenn es eine berschrift in Deutsch gibt: */

if (isset($TITLE_D) && $TITLE_D !== ""){
  $flag_size = GetImageSize($FLAG_D);
  print "<div class=\"lang\">\n<a title=\"$FLAG_D_TITLE\" href=\"galerie.php?src=" . urlencode($src) . "&amp;seite=" . $seite . "\">\n<img src=\"$FLAG_D\" width=\"" . $flag_size[0] . "\" height=\"" . $flag_size[1] . "\" alt=\"$FLAG_D_ALT\" /></a></div>";
}
?>

<div style="text-align:left">
<h1 class="title"><?php echo $TITLE; ?></h1>
<h2 class="subtitle"><?php echo stripslashes($SUBTITLE); ?></h2>
</div> 

<?php 
/* Beschreibung der Thumbnails / THUMBS_TXT */
$text = $src . $THUMBS_TXT;
if (file_exists($text)) {
  print "<div class=\"thumbtext\">";
  @readfile($text);
  print "</div>";
}

/* berprfen, ob Thumbnailsanzahl == Bilderanzahl */ 
$dh  = opendir($src."images");
while (false !== ($filename = readdir($dh))) {
    $files[] = $filename;
}
unset($files[0]);
unset($files[1]);
$images_size = count($files);
closedir($dh); 

/* Warnung, wenn die Anzahl der Thumbnails nicht mit der Anzahl der Bilder bereinstimmt */
if ($size != $images_size) { ?>
  <div style="color:white; background-color:red; border:4px outset #808080; width:75%; margin:auto; 
margin-top:20px; margin-bottom:20px; padding:10px">
     <div style="text-align:center; font-weight:bold; font-size:large; color:white; background-color
:red; padding-bottom:5px">WARNING!</div>
     The number of thumbnails does not equal the number of images!<br />This will cause wrong connections between thumbnails and images!<br /><strong>Solution:</strong> Simply delete all thumbnails!</div>
<?php

}

thumb_nav($seite, $thumbsseiten, $src, $LEFT, $RIGHT, 1);

/* generiert die Thumbnailanzeige */

$tab_rows = ceil(($size - $nr) / 4);
/* In all cases but for the last thumbnail page tab_rows has to be corrected: */
if ($tab_rows > $BPS / 4) $tab_rows = $BPS / 4;

/* print "<p><b>Debug:</b> size: $size, nr: $nr<br> Will attempt to create table with $tab_rows rows</p>"; */

print "<table class=\"thumbnails\">";
for ($i = 0; $i < ($tab_rows); $i++){
  print "\n<tr>";
    for ($j = 0; $j < 4; $j++){
      print "\n  <td>";
      $image_nr = $BPS * ($seite - 1) + 4 * $i + $j;
      if ( $image_nr < $size ){
        print "<a href=\"image.php?src=" . urlencode($src) . "&amp;img=" . strip_jpg($thumbs[$image_nr]) . "\"><img src=\"" . $dir . "/" . $thumbs[$image_nr] . "\" alt=\"" . $thumbs[$image_nr] . "\" title=\"";
        if ($TITLES_ON_THUMBS){ print "\"/><br /> " . get_img_title($thumbs[$image_nr]); }
        else { print get_img_title($thumbs[$image_nr]) . "\"/>"; } 
	print "</a>";
      }
      else{ print "&nbsp;"; }
      print "</td>";
    }
  print "\n</tr>";
}
print "\n</table>";

thumb_nav($seite, $thumbsseiten, $src, $LEFT, $RIGHT, 0);

// Admin Zugriff
@session_start();
if (($_COOKIE["dfg-Admin"] != null && $PASSWORD == $_COOKIE['dfg-Admin']) || ($_SESSION['login']==1)) {
  if ($_POST['configure']) {
    print "<div style=\"margin-left:20%; margin-top:20px; text-align:left\"><strong>Text/Comment:</strong></div>";
    print "<form method=\"post\" action=\"".$_SERVER['REQUEST_URI']." \">";
    print '<input type="hidden" value="true" name="saveTxt" />';
    print "<div style=\"text-align:center; margin-top:10px;\"><textarea name=\"txt\" cols=\"80\" rows=\"20\" >";
    if (file_exists($text)) @readfile($text);
    print "</textarea></div>";
    print "<input type=\"submit\" value=\"save\" name=\"save\" style=\"font-weight:bold; width:140px; height:25px; margin-top:20px;\" /></form>";
    
    print "<form method=\"post\" action=\"".$_SERVER['REQUEST_URI']." \">";
    print "<div style=\"margin-left:20%; margin-top:20px; margin-bottom:10px; text-align:left\"><strong>Manage files:</strong></div>";
    print "<div style=\"margin-left:20%; text-align:left\">";
    print "<input type=\"checkbox\" name=\"delText\" size=\"30\" value=\"delText\" style=\"margin-right:10px\" />Delete text/comment</div><br />";
    print "<input type=\"submit\" value=\"apply\" name=\"apply\" style=\"font-weight:bold; width:140px; height:25px; margin-top:20px;\" /></form>";
    
    print "<div style=\"margin-left:20%; margin-top:20px; margin-bottom:10px; text-align:left\"><strong>Upload image:</strong>";
    print "<form action=\"". $_SERVER['REQUEST_URI']."\" method=\"post\" enctype=\"multipart/form-data\">";
    print "<input type=\"file\" name=\"upload\" size=\"30\" accept=\"*.jpg, *.png\" />";
    print "<input type=\"submit\" value=\"Upload!\" style=\"margin-top:10px; \" />";
    print "</form></div>";
    
    print '<div style="text-align:right; margin-right:5px;"><a href="dfg-admin.php">dfg-Admin</a></div>';
  }  
  else { 
    print "<form method=\"post\" action=\"". $_SERVER['REQUEST_URI'] ."\">";
    print '<input type="hidden" value="true" name="configure" />';
    print '<input type="submit" value="configure" name="edit" style="font-weight:bold; width:140px; height:25px; margin-top:20px; text-align:center;" />';
    print '</form>';
  }
}
?> 

<a href="#Top" class="trenner"><img src="pic/xgoup.png" width="26" height="26" alt="up" title="Top of this page" /></a>

<!-- DO NOT REMOVE THE COPYRIGHT OR YOU OFFEND AGAINST THE LICENSE AGREEMENT!!!
NICHT DAS COPYRIGHT ENTFERNEN ODER DU VERSTSST GEGEN DAS LIZENZ-ABKOMMEN!!! //-->
	<div class="copyright">Gallery created with <a href="http://www.vlado-do.de/download/downloadE.html#dfg" title="dFG download">dFG V<?php echo $DFG_VERSION; ?></a><br />&copy; by <a href="http://www.fieroch.de/" title="Alex Homepage">Alexander Fieroch</a><br /></div>

</div>
</body>
</html>
